/*
 *  TINET (TCP/IP Protocol Stack)
 *
 *  Copyright (C) 2001-2012 by Dep. of Computer Science and Engineering
 *                   Tomakomai National College of Technology, JAPAN
 *
 *  L쌠҂́Cȉ (1)`(4) ̏CFree Software Foundation
 *  ɂČ\Ă GNU General Public License  Version 2 ɋL
 *  qĂ𖞂ꍇɌC{\tgEFAi{\tgEFA
 *  ς̂܂ށDȉjgpEEρEĔzziȉC
 *  pƌĂԁj邱Ƃ𖳏ŋD
 *  (1) {\tgEFA\[XR[ȟ`ŗpꍇɂ́CL̒
 *      \C̗pщL̖ۏ؋K肪Ĉ܂܂̌`Ń\[
 *      XR[hɊ܂܂Ă邱ƁD
 *  (2) {\tgEFACCu`ȂǁC̃\tgEFAJɎg
 *      pł`ōĔzzꍇɂ́CĔzzɔhLgip
 *      ҃}jAȂǁjɁCL̒쌠\C̗pщL
 *      ̖ۏ؋Kfڂ邱ƁD
 *  (3) {\tgEFAC@ɑgݍނȂǁC̃\tgEFAJɎg
 *      płȂ`ōĔzzꍇɂ́C̏𖞂ƁD
 *    (a) ĔzzɔhLgip҃}jAȂǁjɁCL̒
 *        쌠\C̗pщL̖ۏ؋Kfڂ邱ƁD
 *  (4) {\tgEFA̗pɂ蒼ړI܂͊ԐړIɐ邢Ȃ鑹
 *      QCL쌠҂TOPPERSvWFNgƐӂ邱ƁD
 *
 *  {\tgEFÁCۏ؂Œ񋟂Ă̂łDL쌠҂
 *  TOPPERSvWFNǵC{\tgEFAɊւāC̓Kp\
 *  ܂߂āCȂۏ؂sȂD܂C{\tgEFA̗pɂ蒼
 *  ړI܂͊ԐړIɐȂ鑹QɊւĂC̐ӔC𕉂ȂD
 *
 *  @(#) $Id$
 */

#ifndef _IP_IGMP_H_
#define _IP_IGMP_H_

#define NUM_IGMP_ENTRY				5	/* }`LXgO[ṽGg */

#ifdef __CA850__
#pragma pack(1)
#elif __RX
#pragma pack
#elif _MSC_VER
#pragma pack(push, 1)
#endif

 /*
  *  IGMPv1 wb_̒`ARFC 1112
  */

typedef struct t_igmpv1_hdr
{
	uint8_t		type;		/* bZ[W̌^	*/
	uint8_t		unused;		/* gp			*/
	uint16_t	sum;		/* `FbNT		*/
	T_IN4_ADDR	addr;		/* O[vAhX */
} T_IGMPV1_HDR;

/*
*  IGMPv2 wb_̒`ARFC 2236
*/

typedef struct t_igmpv2_hdr
{
	uint8_t		type;		/* bZ[W̌^	*/
	uint8_t		time;		/* ő剞		*/
	uint16_t	sum;		/* `FbNT		*/
	T_IN4_ADDR	addr;		/* O[vAhX */
} T_IGMPV2_HDR;

typedef struct t_igmpv3_query_hdr
{
	uint8_t		type;		/* bZ[W̌^	*/
	uint8_t		time;		/* ő剞		*/
	uint16_t	sum;		/* `FbNT		*/
	T_IN4_ADDR	grpaddr;	/* O[vAhX */
	uint8_t		sqrv;		/* StOAQuerier Robustness Value */
	uint8_t		qqic;		/* Qurier's Query Interval Code */
	uint16_t	num;		/* M̐ */
	T_IN4_ADDR	sdraddr;	/* MAhX */
} T_IGMPV3Q_HDR;

typedef struct t_igmp_group_record
{
	uint8_t		type;		/* bZ[W̌^	*/
	uint8_t		len;		/* ⏕f[^		*/
	uint16_t	num;		/* M̐ */
	T_IN4_ADDR	grpaddr;	/* O[vAhX */
	T_IN4_ADDR	sdraddr;	/* MAhX	*/
							/* ⏕f[^		*/
} T_IGMP_GROUP_RECORD;

typedef struct t_igmpv3_report_hdr
{
	uint8_t		type;		/* bZ[W̌^	*/
	uint8_t		rsv1;		/* \				*/
	uint16_t	sum;		/* `FbNT		*/
	uint16_t	rsv2;		/* \				*/
	uint16_t	num;		/* O[vR[h̐ */
	T_IGMP_GROUP_RECORD record;	/* O[vR[h */
} T_IGMPV3R_HDR;

#ifdef __CA850__
#pragma pack(8)
#elif __RX
#pragma unpack
#elif _MSC_VER
#pragma pack(pop)
#endif

#define IGMP_HDR_SIZE			(sizeof(T_IGMPV1_HDR))
#define IP4_IGMP_HDR_SIZE		(IP4_HDR_SIZE + IGMP_HDR_SIZE)
#define IF_IP4_IGMP_HDR_SIZE		(IF_IP4_HDR_SIZE + IGMP_HDR_SIZE)
#define IF_IP4_IGMP_HDR_OFFSET		(IF_IP4_HDR_SIZE)

#define GET_IGMPV1_HDR(nbuf,ihoff)	((T_IGMPV1_HDR*)((uint8_t*)((nbuf)->buf) + ihoff))
#define GET_IGMPV2_HDR(nbuf,ihoff)	((T_IGMPV2_HDR*)((uint8_t*)((nbuf)->buf) + ihoff))
#define GET_IGMPV3Q_HDR(nbuf,ihoff)	((T_IGMPV3Q_HDR*)((uint8_t*)((nbuf)->buf) + ihoff))
#define GET_IGMPV3R_HDR(nbuf,ihoff)	((T_IGMPV3R_HDR*)((uint8_t*)((nbuf)->buf) + ihoff))
#define GET_IGMP_SDU(nbuf,ihoff)	((uint8_t*)((nbuf)->buf) + ihoff + IGMP_HDR_SIZE)

/*
*  bZ[W̌^
*/

#define IGMP_MEMBERSHIP_QUERY		0x11	/* o[VbvNG[		*/
#define IGMP_MEMBERSHIP_REPORT		0x12	/* o[Vbv|[g		*/
#define IGMP_MEMBERSHIP_REPORT_V2	0x16	/* o[Vbv|[g		*/
#define IGMP_LEAVE_GROUP			0x17	/* [uO[v				*/
#define IGMP_MEMBERSHIP_REPORT_V3	0x22	/* o[Vbv|[g		*/

/*
*  UDPʐM[_IvV
*/

typedef struct ip_mreq
{
	T_IN4_ADDR imr_multiaddr; /* IP multicast address of group */
	T_IN4_ADDR imr_interface; /* local IP address of interface */
} T_IP_MREQ;

typedef struct ip_msfilter
{
	T_IN4_ADDR imsf_multiaddr;     /* IP multicast group address */
	T_IN4_ADDR imsf_interface;     /* IP address of local interface */
	uint32_t   imsf_fmode;         /* Filter-mode */
	uint32_t   imsf_numsrc;        /* Number of sources in the following array */
	T_IN4_ADDR imsf_slist[1];      /* Array of source addresses */
} T_IP_MSFILTER;

#define MCAST_INCLUDE     1
#define MCAST_EXCLUDE     2

extern ER igmp_set_loop(T_UDP_CEP *cep, uint8_t optval);
extern ER igmp_get_loop(T_UDP_CEP *cep, uint8_t *optval);
extern ER igmp_set_ttl(T_UDP_CEP *cep, uint8_t optval);
extern ER igmp_get_ttl(T_UDP_CEP *cep, uint8_t *optval);
extern ER igmp_set_if(T_UDP_CEP *cep, T_IN4_ADDR *optval);
extern ER igmp_get_if(T_UDP_CEP *cep, T_IN4_ADDR *optval);
extern ER igmp_add_membership(T_UDP_CEP *cep, T_IP_MREQ *optval);
extern ER igmp_drop_membership(T_UDP_CEP *cep, T_IP_MREQ *optval);
extern ER igmp_set_ip_msfilter(T_UDP_CEP *cep, const T_IP_MSFILTER *optval);
extern ER igmp_get_ip_msfilter(T_UDP_CEP *cep, T_IP_MSFILTER *optval);

/*
 *  IGMP O[vGg
 */

typedef struct igmp_entry
{
	uint16_t	timer;		/* M܂ł̎[b]	*/
	uint16_t	resptime;	/* ő剞[b]	*/
	T_IN4_ADDR	ip_addr;	/* IP AhX			*/
} T_IGMP_ENTRY;

extern void igmp_init(void);
extern bool_t igmp_is_joined_group(T_IN4_ADDR addr);
extern uint_t igmp_input(T_NET_BUF **inputp, uint_t *offp, uint_t *nextp);

#endif	/* of #ifndef _IP_IGMP_H_ */
